package net.minecraft.src;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.HashMap;
import java.util.Map;

// SDK ModLoader
@SuppressWarnings("rawtypes")
public class ModLoaderMp {
    public static final String NAME = "ModLoaderMP";
	
    private static boolean hasInit = false;
	private static Map<Integer, Class> netClientHandlerEntityMap = null;
	
	public static void Init()
	{
		if(!hasInit)
			init();
	}

	public static void HandleAllPackets(Packet200ModLoader packet200ModLoader)
	{
		if(!hasInit)
            init();
		
		if(packet200ModLoader.modId == NAME.hashCode())
			handleModCheck(packet200ModLoader);
		else
			for(int m = 0; m < ModLoader.getLoadedMods().size(); m++)
	        {
				BaseMod baseMod = (BaseMod)ModLoader.getLoadedMods().get(m);
				if(baseMod instanceof BaseModMp)
				{
					BaseModMp baseModMultiplayer = (BaseModMp)baseMod;
					if (baseModMultiplayer.getId() == packet200ModLoader.modId)
		            {
						baseModMultiplayer.HandlePacket(packet200ModLoader);
		            	break;
		            }
				}
	        }
	}
    
	public static Class HandleNetClientHandlerEntities(int id)
	{
		if(!hasInit)
            init();
        
		if(netClientHandlerEntityMap.containsKey(id))
			return netClientHandlerEntityMap.get(id);
		else
	        return null;
	}
	
	public static void SendPacket(BaseModMp baseModMultiplayer, Packet200ModLoader packet200ModLoader)
	{
		if(!hasInit)
            init();
        
		if(baseModMultiplayer == null)
			throw new IllegalArgumentException("baseModMultiplayer cannot be null.");
		
		packet200ModLoader.modId = baseModMultiplayer.getId();
		sendPacket(packet200ModLoader);
	}
    
	private static void init()
    {
    	hasInit = true;
    	
    	try
    	{
    		// Add custom packet mapping
    		Method method_AddIdClassMapping;
	        try
	        {
	            method_AddIdClassMapping = (Packet.class).getDeclaredMethod("a", new Class[] {
	            		int.class, Class.class
	            });
	        }
	        catch(NoSuchMethodException nosuchmethodexception)
	        {
	        	method_AddIdClassMapping = (Packet.class).getDeclaredMethod("addIdClassMapping", new Class[] {
	        			int.class, Class.class
	            });
	        }
	        method_AddIdClassMapping.setAccessible(true);
	        method_AddIdClassMapping.invoke(null, 200, Packet200ModLoader.class);
    	}
		catch (IllegalAccessException illegalaccessexception)
		{
			ModLoader.getLogger().throwing("ModLoader", "AddCustomPacketMapping", illegalaccessexception);
			ModLoader.ThrowException("ModLoaderMultiplayer", illegalaccessexception);
		}
        catch(IllegalArgumentException illegalargumentexception)
        {
        	ModLoader.getLogger().throwing("ModLoaderMultiplayer", "init", illegalargumentexception);
        	ModLoader.ThrowException("ModLoaderMultiplayer", illegalargumentexception);
            throw new RuntimeException(illegalargumentexception);
        }
		catch(InvocationTargetException invocationtargetexception)
		{
			ModLoader.getLogger().throwing("ModLoader", "init", invocationtargetexception);
			ModLoader.ThrowException("ModLoaderMultiplayer", invocationtargetexception);
		}
        catch(NoSuchMethodException nosuchmethodexception2)
        {
        	ModLoader.getLogger().throwing("ModLoaderMultiplayer", "init", nosuchmethodexception2);
        	ModLoader.ThrowException("ModLoaderMultiplayer", nosuchmethodexception2);
            throw new RuntimeException(nosuchmethodexception2);
        }
    	catch(SecurityException securityexception)
        {
            ModLoader.getLogger().throwing("ModLoaderMultiplayer", "init", securityexception);
            ModLoader.ThrowException("ModLoaderMultiplayer", securityexception);
            throw new RuntimeException(securityexception);
        }
    	
    	// Add all client handler entities
    	netClientHandlerEntityMap = new HashMap<Integer, Class>();
    	for(int m = 0; m < ModLoader.getLoadedMods().size(); m++)
        {
    		BaseMod baseMod = (BaseMod)ModLoader.getLoadedMods().get(m);
    		if(baseMod instanceof BaseModMp)
                ((BaseModMp)baseMod).AddNetClientHandlerEntities(netClientHandlerEntityMap);
        }
    }
	
	private static void handleModCheck(Packet200ModLoader packet200ModLoader)
	{
		Packet200ModLoader packetModCheckResponse = new Packet200ModLoader();
		packetModCheckResponse.modId = NAME.hashCode();
		
		packetModCheckResponse.dataString = new String[ModLoader.getLoadedMods().size()];
		for(int m = 0; m < ModLoader.getLoadedMods().size(); m++)
			packetModCheckResponse.dataString[m] = ((BaseMod)ModLoader.getLoadedMods().get(m)).toString();
		
		sendPacket(packetModCheckResponse);
	}
	
	private static void sendPacket(Packet200ModLoader packet200ModLoader)
	{
		if(ModLoader.getMinecraftInstance().theWorld != null && ModLoader.getMinecraftInstance().theWorld.multiplayerWorld)
			ModLoader.getMinecraftInstance().func_20001_q().addToSendQueue(packet200ModLoader);
	}
	
    private ModLoaderMp() { }
}
