package net.minecraft.src;

import java.io.FileInputStream;
import java.lang.reflect.Field;
import java.lang.reflect.Modifier;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Properties;

import net.minecraft.client.Minecraft;

import org.lwjgl.input.Keyboard;
import org.lwjgl.opengl.GL11;

// TODO Sound range is back to 1
// TODO Lightometer in 64x64, font greater than 64x64
// TODO Sound problems, start requiring audiomod?
// TODO Player spawners in chunks that have never been loaded won't work

// TODO Ammo draws over other stuff
// TODO GUI tick doesn't work
// TODO Guns properties must be sent before FPS properties, right now they aren't
// TODO Nuke won't be set off by fire, oil burns normally
// TODO Direct hit on oil doesn't light it
// TODO Oil texture

// TODO Oil duplicates the bucket
// TODO Flamethrower sentry looks like crap, comes out of the wrong spot
// TODO Flamethrower comes out back of your head

// TODO Rename gatling gun to minigun
// TODO Zoom a bit on all guns, show interface
// TODO Add option that shuffles inventory for guns and nades in hotbar
// TODO Add zoom sound
// TODO Teleporters
// TODO Player spawners for teams
// TODO Teams!

// TODO Gatling gun sentry?
// TODO Dispenser stuff
// TODO Can setSpawnPoint in OSDHook, check for world changed. Maybe even on respawn too
// TODO Bullet casing arc isn't quite right, should go back when you look up
// TODO Incendiary grenades
// TODO getDeathSound for Sentry
// TODO Can probably make rope not need EntityLiving changes, and not need TileEntity either

// TODO Slow mouse on zoom?
// TODO Grenade launcher

// TODO Need to bind sentry to owner... could just say they have to own the area
// TODO Make grenades and rocket launcher not damage blocks in flagged zones
// TODO /ally 0 off 1 see online/offline 2 plus see name 3 plus build in areas, admins see all (toggle)
// TODO Render guns so they look held in hand
// TODO EntityBullet offset to the side for all bipeds, not just player

// SDK
@SuppressWarnings({ "rawtypes", "unchecked" })
public class mod_SdkGuns extends SdkBaseModMp
{
    public static Block blockNuke;
    public static Block blockSentry;
    public static Block blockLighter;
    public static int blockLighterSideIndexInTexture;
    public static Block blockOil;
    public static int blockOilLineIndexInTexture;
    public static Block blockCannon;
    
	public static final Item itemBulletCasing = (new Item(2500)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBulletCasing.png")).setItemName("bulletCasing");
    public static final Item itemBulletLight = (new SdkItemCustomStackSize(2501, 32)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBullet9mm.png")).setItemName("bullet9mm");
    public static final Item itemBulletMedium = (new SdkItemCustomStackSize(2502, 8)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBullet357.png")).setItemName("bullet357");
    public static final Item itemBulletShell = (new SdkItemCustomStackSize(2503, 8)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBulletShell.png")).setItemName("bulletShell");
    public static final Item itemGunAk47 = (new SdkItemGunAk47(2504)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunAk47.png")).setItemName("gunAk47");
    public static final Item itemGunMp5 = (new SdkItemGunMp5(2505)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunMp5.png")).setItemName("gunMp5");
    public static final Item itemGunShotgun = (new SdkItemGunShotgun(2506)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunShotgun.png")).setItemName("gunShotgun");
    public static final Item itemGunDeagle = (new SdkItemGunDeagle(2507)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunDeagle.png")).setItemName("gunDeagle");
    public static final Item itemGrenade = (new SdkItemGrenade(2508, 4)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGrenade.png")).setItemName("grenade");
    public static final Item itemMetalParts = (new Item(2514)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemMetalParts.png")).setItemName("metalParts");
    public static final Item itemBulletRocket = (new SdkItemCustomStackSize(2515, 4)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBulletRocket.png")).setItemName("bulletRocket");
    public static final Item itemGunRocketLauncher = (new SdkItemGunRocketLauncher(2516)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunRocketLauncher.png")).setItemName("gunRocketLauncher");
    public static final Item itemBulletRocketLaser = (new SdkItemCustomStackSize(2517, 4)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBulletRocketLaser.png")).setItemName("bulletRocketLaser");
    public static final Item itemGunRocketLauncherLaser = (new SdkItemGunRocketLauncherLaser(2518)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunRocketLauncherLaser.png")).setItemName("gunRocketLauncherLaser");
    public static final Item itemBulletHeavy = (new SdkItemCustomStackSize(2519, 4)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBullet50Cal.png")).setItemName("bullet50Cal");
    public static final Item itemGunSniper = (new SdkItemGunSniper(2520)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunSniper.png")).setItemName("gunSniper");
    public static final Item itemGrenadeStun = (new SdkItemGrenadeStun(2522, 4)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGrenadeStun.png")).setItemName("grenadeStun");
    public static final Item itemGrenadeSmoke = (new SdkItemGrenadeSmoke(2524, 4)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGrenadeSmoke.png")).setItemName("grenadeSmoke");
    public static final Item itemBulletCasingShell = (new Item(2525)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBulletCasingShell.png")).setItemName("bulletCasingShell");
    public static final Item itemOil = (new SdkItemOil(2526)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemOil.png")).setItemName("itemOil");
    public static final Item itemGunFlamethrower = (new SdkItemGunFlamethrower(2527)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunFlamethrower.png")).setItemName("gunFlamethrower");
    public static final Item itemGrenadeSticky = (new SdkItemGrenadeSticky(2530, 4)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGrenadeSticky.png")).setItemName("grenadeSticky");
    public static final Item itemGunSg552 = (new SdkItemGunSg552(2531)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunSg552.png")).setItemName("gunSg552");
    public static final Item itemGunGatling = (new SdkItemGunGatling(2532)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunGatling.png")).setItemName("gunGatling");

    // Sentry texture indices
    public static Class[] sentryEntityClasses = { SdkEntitySentryAk47.class, SdkEntitySentryMp5.class, SdkEntitySentryShotgun.class, SdkEntitySentryDeagle.class,
    	SdkEntitySentryRocketLauncher.class, SdkEntitySentryRocketLauncherLaser.class, SdkEntitySentrySniper.class, SdkEntitySentryFlamethrower.class, SdkEntitySentrySg552.class };
    public static int[] sentryTextureIndices = {
    	ModLoader.addOverride("/terrain.png", "/sdk/blockSentryAk47.png"),
    	ModLoader.addOverride("/terrain.png", "/sdk/blockSentryMp5.png"),
    	ModLoader.addOverride("/terrain.png", "/sdk/blockSentryShotgun.png"),
    	ModLoader.addOverride("/terrain.png", "/sdk/blockSentryDeagle.png"),
    	ModLoader.addOverride("/terrain.png", "/sdk/blockSentryRocketLauncher.png"),
    	ModLoader.addOverride("/terrain.png", "/sdk/blockSentryRocketLauncherLaser.png"),
    	ModLoader.addOverride("/terrain.png", "/sdk/blockSentrySniper.png"),
    	ModLoader.addOverride("/terrain.png", "/sdk/blockSentryFlamethrower.png"),
    	ModLoader.addOverride("/terrain.png", "/sdk/blockSentrySg552.png")
    };
    
    // Reload
    public static Map<EntityPlayer, Integer> reloadTimes = new HashMap<EntityPlayer, Integer>();
    
    // Recoil
    public static final double RECOIL_FIX_FACTOR = 0.1F;
    public static final double MIN_RECOIL_FIX = 0.5F;
    public static double currentRecoilV = 0F;
    public static double currentRecoilH = 0F;
    
    // Zoom
    public static final float DEFAULT_ZOOM = 1.0F;
    public static final float MAX_ZOOM_SNIPER = 0.125F;
    public static final float MAX_ZOOM_SG552 = 0.25F;
    private static final float ZOOM_INCREMENT = 0.075F;
    private static float currentZoom = DEFAULT_ZOOM;
    private static int lastZoomSlot = 0;
    private static boolean zoomEnabled = false;
    private static float lastZoom = currentZoom;
    
    // Flash
    public static Map<EntityLiving, Pair<Integer, Float>> flashTimes = new HashMap<EntityLiving, Pair<Integer, Float>>();
    
    // Properties
    public static boolean guns = true;
    public static boolean bulletsDestroyGlass = true;
    public static boolean showAmmoBar = true;
    public static boolean muzzleFlash = false;
    public static boolean grenades = true;
    public static boolean grenadesDestroyBlocks = false;
    public static boolean nuke = true;
    public static float nukeBlastDiameter = 8;
    public static int nukeFuse = 80;
    public static boolean oil = true;
    public static boolean lighter = true;
    public static boolean cannon = true;
    public static boolean sentries = true;
    public static boolean sentriesKillAnimals = false;
    public static boolean ammoRestrictions = true;
    public static boolean hardcore = false;
    public static boolean ammoCasings = true;
    public static int zoomKey = Keyboard.KEY_Z;
    public static int reloadKey = Keyboard.KEY_R;
    public static int blockIdNuke = 110;
    public static int blockIdSentry = 111;
    public static int blockIdLighter = 112;
    public static int blockIdOil = 113;
    public static int blockIdCannon = 114;
    
    // For zoom
    public static boolean zoomKeyDown = false;
    private static boolean sniperZoomedIn = false;
    
    // For reload
    public static boolean reloadKeyDown = false;
    
    static
    {
    	loadProperties();
        setHardcore();
    }
    
    private static void loadProperties()
    {
    	Properties properties = new Properties();
    	try
    	{
    		String propertiesPath = mod_SdkGuns.class.getProtectionDomain().getCodeSource().getLocation().toURI().getPath();
    		propertiesPath = propertiesPath.substring(0, propertiesPath.lastIndexOf('/') + 1);
    		propertiesPath += "mod_SdkGuns.properties";
    		
    		properties.load(new FileInputStream(propertiesPath));
    		String property;
    		
    		property = properties.getProperty("guns");
    		guns = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("bulletsDestroyGlass");
    		bulletsDestroyGlass = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("showAmmoBar");
    		showAmmoBar = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("muzzleFlash");
    		muzzleFlash = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("grenades");
    		grenades = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("grenadesDestroyBlocks");
    		grenadesDestroyBlocks = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("nuke");
    		nuke = property.trim().equalsIgnoreCase("true");

    		property = properties.getProperty("nukeBlastDiameter");
    		nukeBlastDiameter = Float.parseFloat(property.trim());

    		property = properties.getProperty("nukeFuse");
    		nukeFuse = Integer.parseInt(property.trim());
    		
    		property = properties.getProperty("oil");
    		oil = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("lighter");
    		lighter = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("cannon");
    		cannon = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("sentries");
    		sentries = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("sentriesKillAnimals");
    		sentriesKillAnimals = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("ammoRestrictions");
    		ammoRestrictions = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("hardcore");
    		hardcore = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("ammoCasings");
    		ammoCasings = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("zoomKey");
    		int tempZoomKey = Keyboard.getKeyIndex(property.trim().toUpperCase());
    		if(tempZoomKey == Keyboard.CHAR_NONE)
    		{
    			System.out.println("Error binding zoom key. Bad key name: " + property.trim());
    		}
    		else
    		{
    			zoomKey = tempZoomKey;
    		}
    		
    		property = properties.getProperty("reloadKey");
    		int tempReloadKey = Keyboard.getKeyIndex(property.trim().toUpperCase());
    		if(tempReloadKey == Keyboard.CHAR_NONE)
    		{
    			System.out.println("Error binding reload key. Bad key name: " + property.trim());
    		}
    		else
    		{
    			reloadKey = tempReloadKey;
    		}
    		
    		property = properties.getProperty("blockIdNuke");
    		blockIdNuke = Integer.parseInt(property.trim());
    		
    		property = properties.getProperty("blockIdSentry");
    		blockIdSentry = Integer.parseInt(property.trim());
    		
    		property = properties.getProperty("blockIdLighter");
    		blockIdLighter = Integer.parseInt(property.trim());
    		
    		property = properties.getProperty("blockIdOil");
    		blockIdOil = Integer.parseInt(property.trim());
    		
    		property = properties.getProperty("blockIdCannon");
    		blockIdCannon = Integer.parseInt(property.trim());
        }
        catch(Exception e)
        {
        	System.out.println("Error loading properties.");
			e.printStackTrace();
        }
    }

	private static void setHardcore()
    {
    	try
		{
    		Field[] fields = EnumCreatureType.class.getDeclaredFields();
			for(int i = 0; i < fields.length; i++)
				if(fields[i].getType() == int.class)
				{
					fields[i].setAccessible(true);
					
					Field modifiersField = Field.class.getDeclaredField("modifiers");
				    modifiersField.setAccessible(true);
				    modifiersField.setInt(fields[i], fields[i].getModifiers() & ~Modifier.FINAL);
					
				    int numMobs, numWaterMobs;
				    if(hardcore)
				    {
				    	numMobs = 700;
				    	numWaterMobs = 50;
				    }
				    else
				    {
				    	numMobs = 70;
				    	numWaterMobs = 5;
				    }
				    
				    fields[i].set(EnumCreatureType.monster, numMobs);
				    fields[i].set(EnumCreatureType.waterCreature, numWaterMobs);
				}
		}
		catch (Exception e)
		{
			System.out.println("Error setting hardcore mode: " + hardcore);
			e.printStackTrace();
		}
    }
	
	public mod_SdkGuns()
	{
		super();
		
		ModLoader.RegisterBlock(blockNuke);
		ModLoader.RegisterBlock(blockSentry, SdkItemSentry.class);
		ModLoader.RegisterBlock(blockLighter);
		ModLoader.RegisterBlock(blockOil);
		ModLoader.RegisterBlock(blockCannon);
		
		ModLoader.AddName(blockNuke, "Nuke");
		ModLoader.AddName(blockSentry, "Sentry");
		ModLoader.AddName(blockLighter, "Lighter");
		ModLoader.AddName(blockOil, "Oil");
		ModLoader.AddName(blockCannon, "Cannon");

		setBurnRates();
	    
		ModLoader.AddName(itemBulletCasing, "Bullet Casing");
		ModLoader.AddName(itemBulletLight, "Light Bullet");
		ModLoader.AddName(itemBulletMedium, "Medium Bullet");
		ModLoader.AddName(itemBulletShell, "Shotgun Shell");
		ModLoader.AddName(itemGunAk47, "AK47");
		ModLoader.AddName(itemGunMp5, "MP5");
		ModLoader.AddName(itemGunShotgun, "Shotgun");
		ModLoader.AddName(itemGunDeagle, "Desert Eagle");
		ModLoader.AddName(itemGrenade, "Grenade");
		ModLoader.AddName(itemMetalParts, "Metal Parts");
		ModLoader.AddName(itemBulletRocket, "Rocket");
		ModLoader.AddName(itemGunRocketLauncher, "Rocket Launcher");
		ModLoader.AddName(itemBulletRocketLaser, "Laser-Guided Rocket");
		ModLoader.AddName(itemGunRocketLauncherLaser, "Laser-Guided Rocket Launcher");
		ModLoader.AddName(itemBulletHeavy, "Heavy Bullet");
		ModLoader.AddName(itemGunSniper, "Sniper Rifle");
		ModLoader.AddName(itemGrenadeStun, "Stun Grenade");
		ModLoader.AddName(itemGrenadeSmoke, "Smoke Grenade");
		ModLoader.AddName(itemBulletCasingShell, "Shell Casing");
		ModLoader.AddName(itemOil, "Oil");
		ModLoader.AddName(itemGunFlamethrower, "Flamethrower");
		ModLoader.AddName(itemGrenadeSticky, "Sticky Grenade");
		ModLoader.AddName(itemGunSg552, "SG552");
		ModLoader.AddName(itemGunGatling, "Gatling Gun");
	    
	    // For showing ammo amount
	    itemBulletLight.maxDamage = 0;
	    itemBulletMedium.maxDamage = 0;
	    itemBulletShell.maxDamage = 0;
	    itemBulletRocket.maxDamage = 0;
	    itemBulletRocketLaser.maxDamage = 0;
	    itemBulletHeavy.maxDamage = 0;
		
		ModLoader.RegisterEntityID(SdkEntityBullet.class, "Bullet", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityBulletShot.class, "Shell", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityBulletCasing.class, "Casing", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityBulletCasingShell.class, "ShellCasing", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityGrenade.class, "Grenade", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityNukePrimed.class, "Nuke", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryAk47.class, "SentryAk47", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryDeagle.class, "SentryDeagle", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryMp5.class, "SentryMp5", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryRocketLauncher.class, "SentryRocketLauncher", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryRocketLauncherLaser.class, "SentryRocketLauncherLaser", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryShotgun.class, "SentryShotgun", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentrySniper.class, "SentrySniper", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityBulletRocket.class, "Rocket", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityBulletRocketLaser.class, "RocketLaser", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityGrenadeStun.class, "GrenadeStun", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityGrenadeSmoke.class, "GrenadeSmoke", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityBulletFlame.class, "Flame", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryFlamethrower.class, "SentryFlamethrower", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityGrenadeSticky.class, "GrenadeSticky", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentrySg552.class, "SentrySg552", ModLoader.getUniqueEntityId());
	}
    
	@Override
    public void InitBlocks()
    {
    	blockNuke = (new SdkBlockNuke(blockIdNuke, ModLoader.addOverride("/terrain.png", "/sdk/blockNuke.png"))).setHardness(0.0F).setStepSound(Block.soundGrassFootstep).setBlockName("nuke");
        blockSentry = (new SdkBlockSentry(blockIdSentry, ModLoader.addOverride("/terrain.png", "/sdk/blockSentry.png"))).setBlockName("sentry");
        blockLighter = (new SdkBlockLighter(blockIdLighter, ModLoader.addOverride("/terrain.png", "/sdk/blockLighterTop.png"))).setHardness(3.5F).setStepSound(Block.soundStoneFootstep).setBlockName("lighter");
        blockLighterSideIndexInTexture = ModLoader.addOverride("/terrain.png", "/sdk/blockLighterSide.png");
        blockOil = (new SdkBlockOil(blockIdOil, ModLoader.addOverride("/terrain.png", "/sdk/blockOilJunction.png"), ModLoader.getUniqueBlockModelID(instance, false))).setHardness(-1F).setBlockName("blockOil");
        blockOilLineIndexInTexture = ModLoader.addOverride("/terrain.png", "/sdk/blockOilLine.png");
        blockCannon = (new SdkBlockCannon(blockIdCannon, ModLoader.addOverride("/terrain.png", "/sdk/blockCannon.png"))).setHardness(3.5F).setStepSound(Block.soundStoneFootstep).setBlockName("cannon");
    }

	public static void setBurnRates()
	{
		//SdkTools.setBurnRate(blockNuke.blockID, 15, 100);
		SdkTools.setBurnRate(blockOil.blockID, 30, 60);
	}
	
	@Override
	public String Version()
	{
		return "1.3_01v5";
	}
	
	@Override
	public void OnTickInGameTick(Minecraft minecraft)
	{
		// Reset things
		if(!minecraft.thePlayer.isEntityAlive())
		{
			currentZoom = DEFAULT_ZOOM;
			
			if(reloadTimes.containsKey(minecraft.thePlayer))
				reloadTimes.remove(minecraft.thePlayer);
			
			if(flashTimes.containsKey(minecraft.thePlayer))
				flashTimes.remove(minecraft.thePlayer);
			
			currentRecoilV = 0;
			currentRecoilH = 0;
		}

		// Handle recoil
		handleRecoil(minecraft);
	
		// Handle reload
		handleReload();
		
		// Handle flash
		handleFlash();
		
		// Handle zoom
		handleZoom(minecraft);
		
		// Handle zoom key
        if(minecraft.currentScreen == null && !Keyboard.isKeyDown(zoomKey) && zoomKeyDown)
        	toggleZoomEnabled();
        zoomKeyDown = Keyboard.isKeyDown(zoomKey);
		
		// Handle reload key
        if(minecraft.currentScreen == null && !Keyboard.isKeyDown(reloadKey) && reloadKeyDown)
    		handleReload(minecraft.theWorld, minecraft.thePlayer, false);
        reloadKeyDown = Keyboard.isKeyDown(reloadKey);
	}
	
	@Override
	public void OnTickInGame(Minecraft minecraft)
	{
		super.OnTickInGame(minecraft);
		
        // Handle drawing
		renderScopeOverlay(minecraft);
		renderFlash(minecraft.thePlayer);
		renderAmmo(minecraft);
	}
	
	@Override
	public void OnMainMenu()
	{
		reset();
	}

	private void reset() {
		loadProperties();
		SetRecipes(CraftingManager.getInstance());
	}

	@Override
	public void SetRecipes(CraftingManager craftingmanager) {
    	itemBulletLight.maxStackSize = 32;
    	itemBulletMedium.maxStackSize = ammoRestrictions ? 8 : 32;
    	itemBulletShell.maxStackSize = ammoRestrictions ? 8 : 32;
    	itemGrenade.maxStackSize = ammoRestrictions ? 4 : 64;
    	itemBulletRocket.maxStackSize = ammoRestrictions ? 4 : 32;
    	itemBulletRocketLaser.maxStackSize = ammoRestrictions ? 4 : 32;
    	itemBulletHeavy.maxStackSize = ammoRestrictions ? 4 : 32;
    	itemGrenadeStun.maxStackSize = ammoRestrictions ? 4 : 64;
    	itemGrenadeSmoke.maxStackSize = ammoRestrictions ? 4 : 64;
    	itemGrenadeSticky.maxStackSize = ammoRestrictions ? 4 : 64;
		
		SdkTools.setShapedRecipe(craftingmanager, nuke, new ItemStack(blockNuke, 1), new Object[] {
            "X#X", "#X#", "X#X", Character.valueOf('X'), Block.tnt, Character.valueOf('#'), Item.redstone
        });
		
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunAk47, 1), new Object[] {
            "X  ", "XX ", " X#", Character.valueOf('X'), itemMetalParts, Character.valueOf('#'), Block.wood
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunMp5, 1), new Object[] {
        	"X  ", "XX ", " XX", Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunDeagle, 1), new Object[] {
        	"XXX", "  X", Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunShotgun, 1), new Object[] {
        	"X  ", "#X ", " XX", Character.valueOf('X'), itemMetalParts, Character.valueOf('#'), Block.wood
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(Item.ingotIron, 1), new Object[] {
        	"XX", "XX", Character.valueOf('X'), itemBulletCasing
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemBulletLight, ammoRestrictions ? 4 : itemBulletLight.maxStackSize), new Object[] {
            "X", "#", Character.valueOf('X'), Item.ingotIron, Character.valueOf('#'), Item.gunpowder
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemBulletMedium, ammoRestrictions ? 4 : itemBulletMedium.maxStackSize), new Object[] {
            "X ", "##", Character.valueOf('X'), Item.ingotIron, Character.valueOf('#'), Item.gunpowder
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemBulletShell, ammoRestrictions ? 4 : itemBulletShell.maxStackSize), new Object[] {
            "X ", "#Y", Character.valueOf('X'), Item.ingotIron, Character.valueOf('#'), Item.gunpowder, Character.valueOf('Y'), Item.paper
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunRocketLauncher, 1), new Object[] {
            "XXX", "XX ", Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunRocketLauncherLaser, 1), new Object[] {
            "#XY", Character.valueOf('#'), Item.diamond, Character.valueOf('X'), itemMetalParts, Character.valueOf('Y'), itemGunRocketLauncher
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemBulletRocket, ammoRestrictions ? 4 : itemBulletRocket.maxStackSize), new Object[] {
            "###", "#X#", "XXX", Character.valueOf('X'), Item.gunpowder, Character.valueOf('#'), Item.ingotIron
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemBulletRocketLaser, ammoRestrictions ? 4 : itemBulletRocketLaser.maxStackSize), new Object[] {
            "#Y#", "#X#", "XXX", Character.valueOf('X'), Item.gunpowder, Character.valueOf('#'), Item.ingotIron,  Character.valueOf('Y'), Item.redstone
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunSniper, 1), new Object[] {
            "X  ", " X#", " XX", Character.valueOf('X'), itemMetalParts, Character.valueOf('#'), Item.diamond
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemBulletHeavy, ammoRestrictions ? 4 : itemBulletHeavy.maxStackSize), new Object[] {
            "XX", "##", Character.valueOf('X'), Item.ingotIron, Character.valueOf('#'), Item.gunpowder
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(Item.ingotIron, 1), new Object[] {
        	"XX", "XX", Character.valueOf('X'), itemBulletCasingShell
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunFlamethrower, 1), new Object[] {
			"X# ", "XX ", " XX", Character.valueOf('X'), itemMetalParts, Character.valueOf('#'), Item.flintAndSteel
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunSg552, 1), new Object[] {
			"X  ", "XX#", " XX", Character.valueOf('X'), itemMetalParts, Character.valueOf('#'), Item.diamond
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunGatling, 1), new Object[] {
			"XX ", "XXX", " XX", Character.valueOf('X'), itemMetalParts
        });
		
		SdkTools.setShapedRecipe(craftingmanager, guns || sentries, new ItemStack(itemMetalParts, 1), new Object[] {
			"##", "##", Character.valueOf('#'), Item.ingotIron
		});
		SdkTools.setShapedRecipe(craftingmanager, guns || sentries, new ItemStack(Item.ingotIron, 4), new Object[] {
			"#", Character.valueOf('#'), itemMetalParts
		});
		
		SdkTools.setShapedRecipe(craftingmanager, grenades, new ItemStack(itemGrenade, 4), new Object[] {
            "X#X", "#X#", "X#X", Character.valueOf('X'), Item.gunpowder, Character.valueOf('#'), Item.ingotIron
        });
		SdkTools.setShapedRecipe(craftingmanager, grenades, new ItemStack(itemGrenadeStun, 4), new Object[] {
            "X#X", "#Y#", "X#X", Character.valueOf('X'), Item.gunpowder, Character.valueOf('#'), Item.ingotIron, Character.valueOf('Y'), Item.lightStoneDust
        });
		SdkTools.setShapedRecipe(craftingmanager, grenades, new ItemStack(itemGrenadeSmoke, 4), new Object[] {
			"X#X", "#Y#", "X#X", Character.valueOf('X'), Item.gunpowder, Character.valueOf('#'), Item.ingotIron, Character.valueOf('Y'), Item.flint
        });
		SdkTools.setShapelessRecipe(craftingmanager, grenades, new ItemStack(itemGrenadeSticky), new Object[] {
            new ItemStack(itemGrenade), new ItemStack(Item.slimeBall)
        });
		
		SdkTools.setShapedRecipe(craftingmanager, sentries && guns, new ItemStack(blockSentry, 1, 0), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunAk47, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(craftingmanager, sentries && guns, new ItemStack(blockSentry, 1, 1), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunMp5, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(craftingmanager, sentries && guns, new ItemStack(blockSentry, 1, 2), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunShotgun, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(craftingmanager, sentries && guns, new ItemStack(blockSentry, 1, 3), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunDeagle, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(craftingmanager, sentries && guns, new ItemStack(blockSentry, 1, 4), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunRocketLauncher, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(craftingmanager, sentries && guns, new ItemStack(blockSentry, 1, 5), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunRocketLauncherLaser, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(craftingmanager, sentries && guns, new ItemStack(blockSentry, 1, 6), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunSniper, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(craftingmanager, sentries && guns, new ItemStack(blockSentry, 1, 7), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunFlamethrower, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(craftingmanager, sentries && guns, new ItemStack(blockSentry, 1, 8), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunSg552, Character.valueOf('X'), itemMetalParts
        });
		
		SdkTools.setShapedRecipe(craftingmanager, sentries && !guns, new ItemStack(blockSentry, 1, 0), new Object[] {
        	" X ", " X ", "X X", Character.valueOf('X'), itemMetalParts
        });
		
		SdkTools.setShapedRecipe(craftingmanager, lighter, new ItemStack(blockLighter, 1), new Object[] {
        	"XXX", "X#X", "XXX", Character.valueOf('X'), Block.cobblestone, Character.valueOf('#'), Item.flintAndSteel
        });
	
		SdkTools.setShapedRecipe(craftingmanager, oil, new ItemStack(itemOil, 1), new Object[] {
        	" X ", "X#X", " X ", Character.valueOf('X'), Item.gunpowder, Character.valueOf('#'), Item.bucketWater
        });
		
		SdkTools.setShapedRecipe(craftingmanager, cannon, new ItemStack(blockCannon, 1), new Object[] {
        	"XXX", "X#X", "XXX", Character.valueOf('X'), Item.ingotIron, Character.valueOf('#'), Item.redstone
        });
	}

	@Override
    public void AddRenderer(Map map)
    {
    	map.put(SdkEntityBullet.class, new SdkRenderBullet());
		map.put(SdkEntityBulletShot.class, new SdkRenderBulletShot());
		map.put(SdkEntityBulletCasing.class, new SdkRenderBulletCasing());
		map.put(SdkEntityBulletCasingShell.class, new SdkRenderBulletCasingShell());
		map.put(SdkEntityNukePrimed.class, new SdkRenderNukePrimed());
		map.put(SdkEntitySentry.class, new SdkRenderSentry());
		map.put(SdkEntityBulletRocket.class, new SdkRenderBulletRocket());
		map.put(SdkEntityBulletRocketLaser.class, new SdkRenderBulletRocketLaser());
		map.put(SdkEntityBulletFlame.class, new SdkRenderBulletFlame());
    }
	
	@Override
	public void AddNetClientHandlerEntities(Map<Integer, Class> map)
	{
		map.put(100, SdkEntityBullet.class);
		map.put(101, SdkEntityBulletShot.class);
		map.put(102, SdkEntityBulletCasing.class);
		map.put(103, SdkEntityBulletCasingShell.class);
		map.put(104, SdkEntityGrenade.class);
		map.put(105, SdkEntityNukePrimed.class);
		map.put(106, SdkEntitySentryAk47.class);
		map.put(107, SdkEntitySentryDeagle.class);
		map.put(108, SdkEntitySentryMp5.class);
		map.put(109, SdkEntitySentryRocketLauncher.class);
		map.put(110, SdkEntitySentryRocketLauncherLaser.class);
		map.put(111, SdkEntitySentryShotgun.class);
		map.put(112, SdkEntitySentrySniper.class);
		map.put(113, SdkEntityBulletRocket.class);
		map.put(114, SdkEntityBulletRocketLaser.class);
		map.put(115, SdkEntityGrenadeStun.class);
		map.put(116, SdkEntityGrenadeSmoke.class);
		map.put(117, SdkEntityBulletFlame.class);
		map.put(118, SdkEntitySentryFlamethrower.class);
		map.put(121, SdkEntityGrenadeSticky.class);
		map.put(122, SdkEntitySentrySg552.class);
	}
	
	@Override
	public void HandlePacket(Packet200ModLoader packet200ModLoader)
	{
		switch(packet200ModLoader.packetType)
		{
			case 1:
			{
				int[] dataInt = packet200ModLoader.dataInt;
				float[] dataFloat = packet200ModLoader.dataFloat;
				guns = dataInt[0] == 1;
				bulletsDestroyGlass = dataInt[1] == 1;
				grenades = dataInt[2] == 1;
				grenadesDestroyBlocks = dataInt[3] == 1;
				nuke = dataInt[4] == 1;
				nukeFuse = dataInt[5];
				oil = dataInt[6] == 1;
				lighter = dataInt[7] == 1;
				cannon = dataInt[8] == 1;
				sentries = dataInt[9] == 1;
				sentriesKillAnimals = dataInt[10] == 1;
				ammoRestrictions = dataInt[11] == 1;
				hardcore = dataInt[12] == 1;
				
				nukeBlastDiameter = dataFloat[0];
				
				SetRecipes(CraftingManager.getInstance());
				break;
			}
		}
	}
    
	public static boolean handleMouse0(boolean buttonDown)
	{
		return false;
	}

	public static boolean handleMouse1(boolean buttonDown)
	{
		return false;
	}

	public static boolean overrideMouseCheck0(int sinceLastUse)
	{
		return false;
	}

	public static boolean overrideMouseCheck1(int sinceLastUse)
	{
		Minecraft minecraft = SdkTools.minecraft;
		
		if(minecraft.thePlayer != null && minecraft.thePlayer.inventory != null)
		{
			ItemStack itemStack = minecraft.thePlayer.inventory.getCurrentItem();
			
			if(itemStack != null
					&& itemStack.getItem() instanceof SdkItemCustomUseDelay
					&& sinceLastUse >= ((SdkItemCustomUseDelay)itemStack.getItem()).useDelay)
				return true;
		}
		
		return false;
	}

	private void handleZoom(Minecraft minecraft) {
		boolean zoomingIn = false;
		float maxZoom = DEFAULT_ZOOM;
		ItemStack itemStack = minecraft.thePlayer.inventory.getCurrentItem();
		if(minecraft.gameSettings != null && minecraft.thePlayer != null && minecraft.thePlayer.inventory != null)
		{
			if(itemStack == null
					|| (itemStack.getItem() != itemGunSniper && itemStack.getItem() != itemGunSg552)
					|| minecraft.thePlayer.inventory.currentItem != lastZoomSlot
					|| minecraft.gameSettings.thirdPersonView
					|| minecraft.currentScreen != null)
			{
				zoomEnabled = false;
			}
			lastZoomSlot = minecraft.thePlayer.inventory.currentItem;
			
			if(zoomEnabled && !minecraft.gameSettings.thirdPersonView)
			{
				if(itemStack.getItem() == itemGunSniper)
				{
					maxZoom = MAX_ZOOM_SNIPER;
				}
				else
				{
					maxZoom = MAX_ZOOM_SG552;
				}
				
				if(currentZoom > maxZoom)
				{
					zoomingIn = true;
				}
			}
		}
		
		if(zoomEnabled && zoomingIn)
			currentZoom = Math.max(maxZoom, currentZoom - ZOOM_INCREMENT);
		else if(!zoomEnabled && currentZoom < DEFAULT_ZOOM)
			currentZoom = Math.min(DEFAULT_ZOOM, currentZoom + ZOOM_INCREMENT);
		
		if(currentZoom == MAX_ZOOM_SNIPER && !sniperZoomedIn && itemStack != null && itemStack.getItem() == itemGunSniper)
		{
			sniperZoomedIn = true;
			
			Packet200ModLoader packet = new Packet200ModLoader();
			packet.packetType = 0;
			packet.dataInt = new int[] { 1 };
			ModLoaderMp.SendPacket(this, packet);
		}
		else if (currentZoom != MAX_ZOOM_SNIPER && sniperZoomedIn)
		{
			sniperZoomedIn = false;
			
			Packet200ModLoader packet = new Packet200ModLoader();
			packet.packetType = 0;
			packet.dataInt = new int[] { 0 };
			ModLoaderMp.SendPacket(this, packet);
		}
		
		if(currentZoom != lastZoom)
			minecraft.entityRenderer.func_21152_a(1 / currentZoom, 0, 0);
		
		lastZoom = currentZoom;
	}

	private void handleFlash() {
		Iterator<Map.Entry<EntityLiving,Pair<Integer, Float>>> it = flashTimes.entrySet().iterator();
		while (it.hasNext())
		{
		    Map.Entry<EntityLiving,Pair<Integer, Float>> entry = it.next();
		    
		    int n = entry.getValue().getLeft() - 1;
		    
		    if (n <= 0)
		    {
		    	entry.getKey().moveSpeed = entry.getValue().getRight();
		        it.remove();
		    }
		    else
		    {
		    	entry.setValue(new Pair<Integer, Float>(n, entry.getValue().getRight()));
		    }
		}
	}

	private void handleReload() {
		Iterator<Map.Entry<EntityPlayer,Integer>> it = reloadTimes.entrySet().iterator();
		while (it.hasNext()) {
		    Map.Entry<EntityPlayer,Integer> entry = it.next();
		    
		    int n = entry.getValue() - 1;
		    
		    if (n <= 0)
		        it.remove();
		    else
		    	entry.setValue(n);
		}
	}

	private void handleRecoil(Minecraft minecraft) {
		double recoilFixV = 0, lastRecoilV = currentRecoilV;
		if(minecraft.thePlayer != null && currentRecoilV > 0D)
		{
			recoilFixV = Math.min(Math.max(currentRecoilV * RECOIL_FIX_FACTOR, MIN_RECOIL_FIX), currentRecoilV);
			currentRecoilV -= recoilFixV;
			minecraft.thePlayer.rotationPitch += recoilFixV;
		}
		
		if(minecraft.thePlayer != null && Math.abs(currentRecoilH) > 0D)
		{
			double recoilFixH;
			if(currentRecoilH > 0D)
				recoilFixH = Math.min(Math.max(currentRecoilH * RECOIL_FIX_FACTOR / 2, MIN_RECOIL_FIX / 2), currentRecoilH);
			else
				recoilFixH = Math.max(Math.min(currentRecoilH * RECOIL_FIX_FACTOR / 2, -MIN_RECOIL_FIX / 2), currentRecoilH);
			
			if(recoilFixV != 0)
			{
				double synchedRecoilFix = recoilFixV / lastRecoilV * currentRecoilH;
				
				if(currentRecoilH > 0D)
					recoilFixH = Math.min(synchedRecoilFix, recoilFixH);
				else
					recoilFixH = Math.max(synchedRecoilFix, recoilFixH);
			}
			
			currentRecoilH -= recoilFixH;
			minecraft.thePlayer.rotationYaw -= recoilFixH;
		}
	}
	
	private void renderAmmo(Minecraft minecraft)
	{
		if(showAmmoBar
				&& minecraft.playerController.shouldDrawHUD()
				&& minecraft.currentScreen == null
				&& (minecraft.gameSettings.thirdPersonView || currentZoom == DEFAULT_ZOOM))
		{
			ItemStack itemStack = minecraft.thePlayer.getCurrentEquippedItem();
		    if(itemStack != null)
		    {
		    	Item item = itemStack.getItem();
		    	if(item instanceof SdkItemGun)
		    	{
					int numStacks = getNumberInInventory(minecraft.thePlayer.inventory, ((SdkItemGun)item).requiredBullet.shiftedIndex);
		    		ScaledResolution scaledresolution = new ScaledResolution(minecraft.displayWidth, minecraft.displayHeight);
		    		int width = scaledresolution.getScaledWidth();
		            int height = scaledresolution.getScaledHeight();
		            
		            // Draw number of clips
		            String numStacksString = ((Integer)(numStacks > 0 ? numStacks - 1 : 0)).toString();
		            int numStacksStringWidth = minecraft.fontRenderer.getStringWidth(numStacksString);
		            minecraft.fontRenderer.drawString(numStacksString, (width / 2 + 91) - numStacksStringWidth, height - 32 - 8, 0xFFFFFF);
		            
		            // Draw number of bullets
		            int ammoCount = mod_SdkGuns.getNumberInFirstStackInInventory(minecraft.thePlayer.inventory, ((SdkItemGun)item).requiredBullet.shiftedIndex);
	        		Tessellator tessellator = Tessellator.instance;
		            if(item instanceof SdkItemGunFlamethrower)
		            {
		            	GL11.glBindTexture(3553 /*GL_TEXTURE_2D*/, minecraft.renderEngine.getTexture("/sdk/guiAmmoOil.png"));
			        	for(int q = ammoCount - 1; q >= 0; q--)
			        	{
			        		int x = (width / 2 + 91) - q - 1 - 14;
			        		int y = height - 32 - 9;
			        		
				            tessellator.startDrawingQuads();
				            tessellator.addVertexWithUV(x, y + 9, -90D, 0.0D, 1.0D);
				            tessellator.addVertexWithUV(x + 1, y + 9, -90D, 1.0D, 1.0D);
				            tessellator.addVertexWithUV(x + 1, y, -90D, 1.0D, 0.0D);
				            tessellator.addVertexWithUV(x, y, -90D, 0.0D, 0.0D);
				            tessellator.draw();
			        	}
		            }
		            else
		            {
			            GL11.glBindTexture(3553 /*GL_TEXTURE_2D*/, minecraft.renderEngine.getTexture("/sdk/guiAmmoBullet.png"));
			        	for(int q = ammoCount - 1; q >= 0; q--)
			        	{
			        		int x = (width / 2 + 91) - q * 2 - 3 - 14;
			        		int y = height - 32 - 9;
			        		
				            tessellator.startDrawingQuads();
				            tessellator.addVertexWithUV(x, y + 9, -90D, 0.0D, 1.0D);
				            tessellator.addVertexWithUV(x + 3, y + 9, -90D, 1.0D, 1.0D);
				            tessellator.addVertexWithUV(x + 3, y, -90D, 1.0D, 0.0D);
				            tessellator.addVertexWithUV(x, y, -90D, 0.0D, 0.0D);
				            tessellator.draw();
			        	}
		            }

		            // Draw number of bullets
		            //GL11.glBindTexture(3553 /*GL_TEXTURE_2D*/, minecraft.renderEngine.getTexture("/sdk/guiAmmo.png"));
		            //int ammoCount = mod_SdkGuns.getNumberInFirstStackInInventory(minecraft.thePlayer.inventory, ((SdkItemGun)item).requiredBullet.shiftedIndex);
		        	//for(int q = 0; q < ammoCount; q++)
		        		//if(item instanceof SdkItemGunFlamethrower)
		        			//minecraft.ingameGUI.drawTexturedModalRect((width / 2 + 91) - q - 1 - 14, height - 32 - 9, 3, 0, 1, 9);
		        		//else
		        			//minecraft.ingameGUI.drawTexturedModalRect((width / 2 + 91) - q * 2 - 3 - 14, height - 32 - 9, 0, 0, 3, 9);
		    	}
		    }
		}
	}

	private void renderScopeOverlay(Minecraft minecraft)
	{
		if(!minecraft.gameSettings.thirdPersonView && currentZoom != DEFAULT_ZOOM && minecraft.currentScreen == null)
	        SdkTools.renderTextureOverlay("%blur%/sdk/miscScope.png", 1F);
	}

	private void renderFlash(EntityPlayer entityplayer)
	{
		if(getFlash(entityplayer) != 0F && SdkTools.minecraft.currentScreen == null)
			SdkTools.renderTextureOverlay("%blur%/sdk/miscFlash.png", getFlash(entityplayer));
	}
	
	private static void toggleZoomEnabled()
	{
		zoomEnabled = !zoomEnabled;
	}

	public static void handleReload(World world, EntityPlayer entityPlayer, boolean forcedReload)
	{
		if(!reloadTimes.containsKey(entityPlayer))
		{
			ItemStack itemStack = entityPlayer.getCurrentEquippedItem();
			if(itemStack != null && itemStack.getItem() instanceof SdkItemGun)
			{
				Item ammo = ((SdkItemGun)itemStack.getItem()).requiredBullet;
	
				int firstIndex = -1;
				int firstAmmoAmount = -1, secondAmmoAmount = -1;
				boolean hasReloaded = false;
				do
				{
					secondAmmoAmount = -1;
					
					InventoryPlayer inventory = entityPlayer.inventory;
					for(int j = firstIndex + 1; j < inventory.mainInventory.length; j++)
			            if(inventory.mainInventory[j] != null && inventory.mainInventory[j].itemID == ammo.shiftedIndex)
			            {
			            	if(ammo.maxDamage > 0)
			            	{
			            		int fullAmmoCount = ammo.maxDamage + 1;
			            		
			            		if(firstIndex == -1)
			            		{
			            			// Get size of first stack
			            			firstAmmoAmount = fullAmmoCount - getItemDamage(inventory.mainInventory[j]);
			    					
			    					// Break if full
			    					if(!forcedReload && ammo.maxDamage > 0 && firstAmmoAmount == ammo.maxDamage + 1)
			    						break;
			            		}
			            		else
			            		{
			            			// Reload
			            			if(!hasReloaded)
			            			{
			            				reload(world, entityPlayer);
			            				hasReloaded = true;
			            			}
			            			
			            			// Get size of second stack
			            			secondAmmoAmount = fullAmmoCount - getItemDamage(inventory.mainInventory[j]);
			            			
			            			// Find out how much ammo to shift
			            			int ammoToShift = Math.min(fullAmmoCount - firstAmmoAmount, secondAmmoAmount);
			            			
			            			// Shift ammo
			            			firstAmmoAmount += ammoToShift;
			            			secondAmmoAmount -= ammoToShift;
			            			setItemDamage(inventory.mainInventory[firstIndex], fullAmmoCount - firstAmmoAmount);
			            			setItemDamage(inventory.mainInventory[j], fullAmmoCount - secondAmmoAmount);
		            				
		            				// Nullify empty stack
		            				if(secondAmmoAmount == 0)
		            					inventory.mainInventory[j] = new ItemStack(Item.bucketEmpty);
		            				
		            				break;
			            		}
			            	}
			            	else
			            	{
			            		if(firstIndex == -1)
			            		{
			            			// Get size of first stack
			            			firstAmmoAmount = inventory.mainInventory[j].stackSize;
			    					
			    					// Break if full
			    					if(!forcedReload && ammo.maxDamage == 0 && firstAmmoAmount == ammo.maxStackSize)
			    						break;
			            		}
			            		else
			            		{
			            			// Reload
			            			if(!hasReloaded)
			            			{
			            				reload(world, entityPlayer);
			            				hasReloaded = true;
			            			}
			            			
			            			// Get size of second stack
			            			secondAmmoAmount = inventory.mainInventory[j].stackSize;
			            			
			            			// Find out how much ammo to shift
			            			int ammoToShift = Math.min(ammo.maxStackSize - firstAmmoAmount, secondAmmoAmount);
			            			
			            			// Shift ammo
			            			firstAmmoAmount += ammoToShift;
			            			secondAmmoAmount -= ammoToShift;
			            			inventory.mainInventory[firstIndex].stackSize = firstAmmoAmount;
		            				inventory.mainInventory[j].stackSize = secondAmmoAmount;
		            				
		            				// Nullify empty stack
		            				if(secondAmmoAmount == 0)
		            					inventory.mainInventory[j] = null;
		            				
		            				break;
			            		}
			            	}
			            	
			            	if(firstIndex == -1)
			            		firstIndex = j;
			            }
					
					// Break if no ammo found
					if(firstIndex == -1)
						break;
					
					// Reload and break if forced
					if(!hasReloaded && forcedReload)
					{
						reload(world, entityPlayer);
						break;
					}
					
					// Break if only one ammo stack found
					if(secondAmmoAmount == -1)
						break;
					
					// Break if full
					if(ammo.maxDamage == 0 && firstAmmoAmount == ammo.maxStackSize)
						break;
					
					// Break if full
					if(ammo.maxDamage > 0 && firstAmmoAmount == ammo.maxDamage + 1)
						break;
				}
				while(true);
			}
		}
	}
	
	public static void reload(World world, EntityPlayer entityplayer)
	{
		world.playSoundAtEntity(entityplayer, "sdk.reload", 1.0F, 1.0F / (entityplayer.rand.nextFloat() * 0.1F + 0.95F));
		reloadTimes.put(entityplayer, 40);
	}

	public static boolean getSniperZoomedIn()
	{
		return sniperZoomedIn;
	}
	
	public static float getFlash(EntityPlayer entityplayer)
	{
		if(flashTimes.containsKey(entityplayer))
    	{
    		return (float)flashTimes.get(entityplayer).getLeft() / SdkEntityGrenadeStun.MAX_FLASH_TIME_PLAYER;
    	}
		else
		{
			return 0.0F;
		}
	}
	
	public static int getNumberInFirstStackInInventory(InventoryPlayer inventory, int itemID)
    {
        for(int j = 0; j < inventory.mainInventory.length; j++)
        {
            if(inventory.mainInventory[j] != null && inventory.mainInventory[j].itemID == itemID)
            {
            	if(inventory.mainInventory[j].getItem().maxDamage > 0)
            	{
            		return inventory.mainInventory[j].getItem().maxDamage - getItemDamage(inventory.mainInventory[j]) + 1;
            	}
            	else
            	{
            		return inventory.mainInventory[j].stackSize;
            	}
            }
        }

        return -1;
    }
	
	public static int getNumberInInventory(InventoryPlayer inventory, int i)
    {
		int num = 0;
		
        for(int j = 0; j < inventory.mainInventory.length; j++)
        {
            if(inventory.mainInventory[j] != null && inventory.mainInventory[j].itemID == i)
            {
            	num++;
            }
        }

        return num;
    }
	
	public static int getNumberInFirstStackInHotbar(InventoryPlayer inventory, int i)
    {
        for(int j = 0; j < 9; j++)
        {
            if(inventory.mainInventory[j] != null && inventory.mainInventory[j].itemID == i)
            {
                return inventory.mainInventory[j].stackSize;
            }
        }

        return -1;
    }
	
	public static boolean playerInventoryEmpty(InventoryPlayer inventory)
    {
        for(int j = 0; j < inventory.mainInventory.length; j++)
        {
            if(inventory.mainInventory[j] != null)
            {
            	return false;
            }
        }
        
        for(int j = 0; j < inventory.armorInventory.length; j++)
        {
            if(inventory.armorInventory[j] != null)
            {
            	return false;
            }
        }
        
        return true;
    }
	
	public static int getItemDamage(ItemStack itemStack)
	{
		try
		{
			return (Integer)ModLoader.getPrivateValue(ItemStack.class, itemStack, 3);
		}
		catch (NoSuchFieldException ex)
		{
			System.out.println("Error getting item damage.");
		}
		
		return 0;
	}
	
	public static void setItemDamage(ItemStack itemStack, int itemDamage)
	{
		try
		{
			ModLoader.setPrivateValue(ItemStack.class, itemStack, 3, itemDamage);
		}
		catch (NoSuchFieldException ex)
		{
			System.out.println("Error setting item damage.");
		}
	}
	
	@Override
    public boolean RenderWorldBlock(RenderBlocks renderblocks, IBlockAccess iblockaccess, int i, int j, int k, Block block, int l)
	{
		try
		{
	        if(l == blockOil.getRenderType())
	        {
	            return renderBlockOil(block, i, j, k, iblockaccess);
	        }
		}
		catch (Exception e)
		{
			System.out.println("Error rendering mod_SdkGuns.");
			e.printStackTrace();
		}
		
		return false;
	}
	
	public static boolean renderBlockOil(Block block, int i, int j, int k, IBlockAccess blockAccess)
    {
        Tessellator tessellator = Tessellator.instance;
        int l = block.getBlockTextureFromSideAndMetadata(1, blockAccess.getBlockMetadata(i, j, k));
        float f = block.getBlockBrightness(blockAccess, i, j, k);
        tessellator.setColorOpaque_F(f, f, f);
        int i1 = (l & 0xf) << 4;
        int j1 = l & 0xf0;
        double d = (float)i1 / 256F;
        double d1 = ((float)i1 + 15.99F) / 256F;
        double d2 = (float)j1 / 256F;
        double d3 = ((float)j1 + 15.99F) / 256F;
        float f1 = 0.0F;
        float f2 = 0.03125F;
        boolean flag = blockAccess.getBlockId(i - 1, j, k) == blockOil.blockID || !blockAccess.isBlockOpaqueCube(i - 1, j, k) && blockAccess.getBlockId(i - 1, j - 1, k) == blockOil.blockID;
        boolean flag1 = blockAccess.getBlockId(i + 1, j, k) == blockOil.blockID || !blockAccess.isBlockOpaqueCube(i + 1, j, k) && blockAccess.getBlockId(i + 1, j - 1, k) == blockOil.blockID;
        boolean flag2 = blockAccess.getBlockId(i, j, k - 1) == blockOil.blockID || !blockAccess.isBlockOpaqueCube(i, j, k - 1) && blockAccess.getBlockId(i, j - 1, k - 1) == blockOil.blockID;
        boolean flag3 = blockAccess.getBlockId(i, j, k + 1) == blockOil.blockID || !blockAccess.isBlockOpaqueCube(i, j, k + 1) && blockAccess.getBlockId(i, j - 1, k + 1) == blockOil.blockID;
        if(!blockAccess.isBlockOpaqueCube(i, j + 1, k))
        {
            if(blockAccess.isBlockOpaqueCube(i - 1, j, k) && blockAccess.getBlockId(i - 1, j + 1, k) == blockOil.blockID)
            {
                flag = true;
            }
            if(blockAccess.isBlockOpaqueCube(i + 1, j, k) && blockAccess.getBlockId(i + 1, j + 1, k) == blockOil.blockID)
            {
                flag1 = true;
            }
            if(blockAccess.isBlockOpaqueCube(i, j, k - 1) && blockAccess.getBlockId(i, j + 1, k - 1) == blockOil.blockID)
            {
                flag2 = true;
            }
            if(blockAccess.isBlockOpaqueCube(i, j, k + 1) && blockAccess.getBlockId(i, j + 1, k + 1) == blockOil.blockID)
            {
                flag3 = true;
            }
        }
        float f3 = 0.3125F;
        float f4 = i + 0;
        float f5 = i + 1;
        float f6 = k + 0;
        float f7 = k + 1;
        byte byte0 = 0;
        if((flag || flag1) && !flag2 && !flag3)
        {
            byte0 = 1;
        }
        if((flag2 || flag3) && !flag1 && !flag)
        {
            byte0 = 2;
        }
        if(byte0 != 0)
        {
            d = (float)(i1 + 16) / 256F;
            d1 = ((float)(i1 + 16) + 15.99F) / 256F;
            d2 = (float)j1 / 256F;
            d3 = ((float)j1 + 15.99F) / 256F;
        }
        if(byte0 == 0)
        {
            if(flag1 || flag2 || flag3 || flag)
            {
                if(!flag)
                {
                    f4 += f3;
                }
                if(!flag)
                {
                    d += f3 / 16F;
                }
                if(!flag1)
                {
                    f5 -= f3;
                }
                if(!flag1)
                {
                    d1 -= f3 / 16F;
                }
                if(!flag2)
                {
                    f6 += f3;
                }
                if(!flag2)
                {
                    d2 += f3 / 16F;
                }
                if(!flag3)
                {
                    f7 -= f3;
                }
                if(!flag3)
                {
                    d3 -= f3 / 16F;
                }
            }
            tessellator.addVertexWithUV(f5 + f1, (float)j + f2, f7 + f1, d1, d3);
            tessellator.addVertexWithUV(f5 + f1, (float)j + f2, f6 - f1, d1, d2);
            tessellator.addVertexWithUV(f4 - f1, (float)j + f2, f6 - f1, d, d2);
            tessellator.addVertexWithUV(f4 - f1, (float)j + f2, f7 + f1, d, d3);
        }
        if(byte0 == 1)
        {
            tessellator.addVertexWithUV(f5 + f1, (float)j + f2, f7 + f1, d1, d3);
            tessellator.addVertexWithUV(f5 + f1, (float)j + f2, f6 - f1, d1, d2);
            tessellator.addVertexWithUV(f4 - f1, (float)j + f2, f6 - f1, d, d2);
            tessellator.addVertexWithUV(f4 - f1, (float)j + f2, f7 + f1, d, d3);
        }
        if(byte0 == 2)
        {
            tessellator.addVertexWithUV(f5 + f1, (float)j + f2, f7 + f1, d1, d3);
            tessellator.addVertexWithUV(f5 + f1, (float)j + f2, f6 - f1, d, d3);
            tessellator.addVertexWithUV(f4 - f1, (float)j + f2, f6 - f1, d, d2);
            tessellator.addVertexWithUV(f4 - f1, (float)j + f2, f7 + f1, d1, d2);
        }
        d = (float)(i1 + 16) / 256F;
        d1 = ((float)(i1 + 16) + 15.99F) / 256F;
        d2 = (float)j1 / 256F;
        d3 = ((float)j1 + 15.99F) / 256F;
        if(!blockAccess.isBlockOpaqueCube(i, j + 1, k))
        {
            if(blockAccess.isBlockOpaqueCube(i - 1, j, k) && blockAccess.getBlockId(i - 1, j + 1, k) == blockOil.blockID)
            {
                tessellator.addVertexWithUV((float)i + f2, (float)(j + 1) + f1, (float)(k + 1) + f1, d1, d2);
                tessellator.addVertexWithUV((float)i + f2, (float)(j + 0) - f1, (float)(k + 1) + f1, d, d2);
                tessellator.addVertexWithUV((float)i + f2, (float)(j + 0) - f1, (float)(k + 0) - f1, d, d3);
                tessellator.addVertexWithUV((float)i + f2, (float)(j + 1) + f1, (float)(k + 0) - f1, d1, d3);
            }
            if(blockAccess.isBlockOpaqueCube(i + 1, j, k) && blockAccess.getBlockId(i + 1, j + 1, k) == blockOil.blockID)
            {
                tessellator.addVertexWithUV((float)(i + 1) - f2, (float)(j + 0) - f1, (float)(k + 1) + f1, d, d3);
                tessellator.addVertexWithUV((float)(i + 1) - f2, (float)(j + 1) + f1, (float)(k + 1) + f1, d1, d3);
                tessellator.addVertexWithUV((float)(i + 1) - f2, (float)(j + 1) + f1, (float)(k + 0) - f1, d1, d2);
                tessellator.addVertexWithUV((float)(i + 1) - f2, (float)(j + 0) - f1, (float)(k + 0) - f1, d, d2);
            }
            if(blockAccess.isBlockOpaqueCube(i, j, k - 1) && blockAccess.getBlockId(i, j + 1, k - 1) == blockOil.blockID)
            {
                tessellator.addVertexWithUV((float)(i + 1) + f1, (float)(j + 0) - f1, (float)k + f2, d, d3);
                tessellator.addVertexWithUV((float)(i + 1) + f1, (float)(j + 1) + f1, (float)k + f2, d1, d3);
                tessellator.addVertexWithUV((float)(i + 0) - f1, (float)(j + 1) + f1, (float)k + f2, d1, d2);
                tessellator.addVertexWithUV((float)(i + 0) - f1, (float)(j + 0) - f1, (float)k + f2, d, d2);
            }
            if(blockAccess.isBlockOpaqueCube(i, j, k + 1) && blockAccess.getBlockId(i, j + 1, k + 1) == blockOil.blockID)
            {
                tessellator.addVertexWithUV((float)(i + 1) + f1, (float)(j + 1) + f1, (float)(k + 1) - f2, d1, d2);
                tessellator.addVertexWithUV((float)(i + 1) + f1, (float)(j + 0) - f1, (float)(k + 1) - f2, d, d2);
                tessellator.addVertexWithUV((float)(i + 0) - f1, (float)(j + 0) - f1, (float)(k + 1) - f2, d, d3);
                tessellator.addVertexWithUV((float)(i + 0) - f1, (float)(j + 1) + f1, (float)(k + 1) - f2, d1, d3);
            }
        }
        
        return true;
    }
}
